

// 25::second => now;

// // A5
// 81 => int note;

// fun void playBell(float velocity, MelloBell @ bell) {
//     bell.freq(Std.mtof(note));
//     spork ~ bell.playNote(velocity);
// }

// fun float easeCircularIn(float value) {
//     if (value - 1.0 < 0.001) {
//         return 1.0;
//     }
//     return -1.0 * (Math.sqrt(1.0 - Math.pow(value, 2.0)) - 1.0);
// }


// // 4 descending tritones
// for(0 => int i; i < 4; i++) {
//     easeCircularIn((5-i)/5) => float exponentialVelocity;
//     playBell(exponentialVelocity, bells[0]);
//     6 -=> note;
//     0.25::second => now;
// }

// fun void moreDescendingTritones() {
//     81 => note;
//     // 4 descending tritones
//     for(0 => int i; i < 7; i++) {
//         easeCircularIn((i+1)/8) => float exponentialVelocity;
//         playBell(exponentialVelocity, bells[i]);
//         6 -=> note;
//         0.10::second => now;
//     }  
// }
// spork ~ moreDescendingTritones();

// 0.10::second*6 => now;

// for(0 => int i; i < drones.size(); i++) {
//     drones[i] @=> SeparatingFM @ drone;

//     drone.duration(30::second);
//     spork ~ drone.noteOn();
//     spork ~ drone.increaseModulatorFreq(18::second);

//     1::second => now;
// }


// 40::second => now;

/**
 *  @class      My extremely musical statement
 *  @extends    Score
 **/
public class AStatement extends Score {

    this.duration(240::second);

    SeparatingFM drones[5];
    // for(0 => int i; i < drones.size(); i++) {
    //     drones[i].gain(1/drones.size()$float);
    // }

    OfficePhone phones[10];

    UFOEngine ufo;

    RandomBellsPerformer bellPerformer;
    bellPerformer.score(this);


    /**
     *  @class      Basic intro opens with desolate FM separating sound.
     *  @extends    Score.Movement
     **/
    class Intro extends Score.Movement {
        fun void play() {
            this.pre_play();

            this.score() $ AStatement @=> AStatement @ score;
            score.drones[0] @=> SeparatingFM @ drone;

            this.duration()*0.05 => dur droneInDuration;
            this.duration()*0.10 => dur droneOnsetDuration;
            this.duration()*0.35 => dur droneIncreaseDuration;
            this.duration()*0.20 => dur droneStableDuration;
            this.duration()*0.25 => dur droneOutDuration;
            this.duration()*0.05 => dur silenceDuration;

            drone.noteOn(droneInDuration);
            droneInDuration+droneOnsetDuration => now;
            spork ~ drone.increaseModulatorFreq(droneIncreaseDuration) @=> Shred @ droneModulator;
            droneIncreaseDuration+droneStableDuration => now;
            drone.noteOff(droneOutDuration);
            droneOutDuration => now;
            droneModulator.exit();

            silenceDuration => now;
            me.yield();
        }
    }
    Intro intro;
    this.add_movement(intro);
    intro.duration(0.25);

    /**
     *  @class      A lot of phone ringing
     *  @extends    Score.Movement
     **/
    class TimeTribute extends Score.Movement {
        fun void play() {
            this.pre_play();

            this.score() $ AStatement @=> AStatement @ score;

            score.phones @=> OfficePhone @ phones[];


            float phoneGain;
            for(0 => int i; i < phones.size(); i++) {

                // Math.pow(1/(i+1)$float - 1, 5.0)+1.0 => phoneGain;
                1/(i+1)$float => phoneGain;

                for(0 => int j; j < i+1; j++) {
                    phones[j].gain(0.9*phoneGain);
                }

                float phoneFreq;
                if(i == 0) {
                    440 => phoneFreq;
                }
                else if(i == 1) {
                    220 => phoneFreq;
                }
                else if(i == 2) {
                    110 => phoneFreq;
                }
                else {
                    Std.rand2f(55, 880) => phoneFreq;
                }
                phones[i].freq(phoneFreq);
                spork ~ phones[i].noteOn();
                Std.rand2f(0.25, 1.25)*1.5::second => now;
            }

            2::second => now;

            // Descending drone sounds
            score.drones @=> SeparatingFM @ drones[];

            for(0 => int i; i < drones.size(); i++) {
                drones[i].gain(0.8/drones.size()$float);
                drones[i].modulatorFreq(Std.mtof(63));
                spork ~ drones[i].decreaseModulatorFreq(10::second);
                drones[i].noteOn();

                1::second => now;
            }

            10::second => now;

            score.ufo @=> UFOEngine @ ufo;

            ufo.gain(0.25);
            ufo.freq(220);

            ufo.noteOn(this.remaining_time());

            for(0 => int i; i < phones.size(); i++) {
                phones[i].noteOff(this.remaining_time());
            }

            for(0 => int i; i < drones.size(); i++) {
                drones[i].e.duration(this.remaining_time());
                drones[i].e.target(0.5);
            }

            this.remaining_time() => now;
        }
    }
    TimeTribute t;
    this.add_movement(t);
    t.duration(0.25);

    /**
     *  @class      Some bells enter here
     *  @extends    Score.Movement
     **/
    class Bells extends Score.Movement {

        fun void play() {
            this.pre_play();

            this.score() $ AStatement @=> AStatement @ score;
            spork ~ score.bellPerformer.play();
            spork ~ score.bellPerformer.speedUpNotes(this.remaining_time());

            this.remaining_time() => now;
        }

    }
    Bells b;
    this.add_movement(b);
    b.duration(0.25);

    /**
     *  @class      
     *  @extends    Score.Movement
     **/
    class Ending extends Score.Movement {
        fun void play() {
            this.pre_play();

            this.score() $ AStatement @=> AStatement @ score;

            spork ~ score.bellPerformer.play();
            spork ~ score.bellPerformer.slowDownNotes(this.remaining_time()*0.5);

            spork ~ score.ufo.envelopeToFilterModulatorFreq();
            spork ~ score.ufo.noteOff(this.remaining_time()*0.8);

            score.drones @=> SeparatingFM @ drones[];

            this.remaining_time() => dur remaining;
            for(0 => int i; i < drones.size(); i++) {
                spork ~ drones[i].increaseModulatorIndex2(remaining*0.8);
                drones[i].e.duration(remaining*0.8);
                drones[i].e.target(0.9);
            }

            remaining*0.5 => now;
            score.bellPerformer.stop();

            remaining*0.3 => now;

            for(0 => int i; i < drones.size(); i++) {
                spork ~ drones[i].decreaseModulatorIndex2(0.5::second);
            }

            0.5::second => now;

            for(0 => int i; i < drones.size(); i++) {
                spork ~ drones[i].noteOff(0.5::second);
            }
            this.remaining_time() => now;
        }
    }
    Ending e;
    this.add_movement(e);
    e.duration(0.25);

}

AStatement score;
score.play();