/**
 *  @file       OfficePhone.ck
 *
 *  @author     Colin Sullivan <colinsul [at] gmail.com>
 *
 *              Copyright (c) 2012 Colin Sullivan
 *              Licensed under the MIT license.
 **/

/**
 *  @class      Office phone ringing sound.
 *  @extends    Instrument
 **/
public class OfficePhone extends Instrument {
    TriOsc carrier => Envelope e => outputsAll;

    2 => carrier.sync;
    SqrOsc modulator => carrier;

    // Std.mtof(60) => carrier.freq;

    fun float freq(float aFreq) {
        aFreq => _freq;

        carrier.freq(_freq);

        return this.freq();
    }

    1000 => modulator.gain;
    Std.mtof(5) => modulator.freq;

    fun void noteOn() {
        e.keyOn();    
    }

    fun void noteOff() {
        e.keyOff();    
    }

    fun void noteOff(dur aDuration) {
        e.duration(aDuration);
        e.keyOff();
    }
}

// OfficePhone phone;
// phone.freq(440);
// phone.noteOn();
// 1::second => now;
// phone.noteOff();
// 1::second => now;